# 0.7.0

##### New
* Importing the "test" module now adds a `bugHunt(…)` method to `Gen`s,
  to find a seed that deterministically produces failure-inducing random data.
* Add `Gen.optionGet` to turn `Gen[Option[A]]` into `Gen[A]` by regenerating when empty.
* Add `Gen.orderedSeq` to generate a sequence of elements in a fixed order.
* Add `Gen.reseed` to apply a new, random seed to the RNG.
* Add `Gen.tailrec` for stack-safe tail-recursive generators.
* Add `Gen.tryGenChooseLazily`.
* Add `StateGen` as an alias for `scalaz.StateT[Gen,?,?]` with helpers.
* Add a Scalaz `BindRec` instance for `Gen`.
* Add `GenCtx.nextIntN(): Int` to generate ints in range [0,N) where N is in {2,4,8,16}.
* Add `GenCtx.shiftLeft(Int): Int` to shift left and add a random bit.

##### Changes
* Allow test data to be provided as in `Iterator` in `{Prop,Eval,EvalOver}.{whitelist,blacklist,allPresent}`.
* `Gen.choose`-like methods now accept a `TraversableOnce` instead of a `Seq`.
* Deprecated `Gen#nel` and replaced with `Gen#scalazNEL`.
* `nyaya.test.{Satisfied,Proved,Falsified,Error}` renamed to
  <br> `nyaya.test.Result.{Satisfied,Proved,Falsified,Error}`.

##### Performance Improvements
* Speed up `Gen.choose*` when there are {1,2,4,8,16} available choices.
* Improve effeciency of `SizeSpec`s of ranges with only one value.
* Stop using `Stream` internally, replace mostly with `Iterator` for more speed & less mem.
  <br> (Example: https://japgolly.github.io/scalajs-benchmark/#/scala/flatmap)
* Stop using `scalaz.NonEmptyList` internally (and thus `scalaz.IList`).
  <br> Reduces footprint and Scala.JS output.
